Index: uspace/srv/hid/compositor/compositor.c
===================================================================
--- uspace/srv/hid/compositor/compositor.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/srv/hid/compositor/compositor.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -90,4 +90,5 @@
 typedef struct {
 	link_t link;
+	atomic_t ref_cnt;
 	service_id_t in_dsid;
 	service_id_t out_dsid;
@@ -138,4 +139,5 @@
 } viewport_t;
 
+static desktop_rect_t viewport_bound_rect;
 static FIBRIL_MUTEX_INITIALIZE(viewport_list_mtx);
 static LIST_INITIALIZE(viewport_list);
@@ -215,4 +217,5 @@
 
 	link_initialize(&win->link);
+	atomic_set(&win->ref_cnt, 0);
 	prodcons_initialize(&win->queue);
 	transform_identity(&win->transform);
@@ -232,5 +235,11 @@
 static void window_destroy(window_t *win)
 {
-	if (win) {
+	if (win && atomic_get(&win->ref_cnt) == 0) {
+		while (!list_empty(&win->queue.list)) {
+			window_event_t *event = (window_event_t *) list_first(&win->queue.list);
+			list_remove(&event->link);
+			free(event);
+		}
+
 		if (win->surface) {
 			surface_destroy(win->surface);
@@ -310,4 +319,52 @@
 }
 
+static void comp_restrict_pointers(void)
+{
+	fibril_mutex_lock(&viewport_list_mtx);
+
+	sysarg_t x_res = coord_origin;
+	sysarg_t y_res = coord_origin;
+	sysarg_t w_res = 0;
+	sysarg_t h_res = 0;
+
+	if (!list_empty(&viewport_list)) {
+		viewport_t *vp = (viewport_t *) list_first(&viewport_list);
+		x_res = vp->pos.x;
+		y_res = vp->pos.y;
+		surface_get_resolution(vp->surface, &w_res, &h_res);
+	}
+
+	list_foreach(viewport_list, link) {
+		viewport_t *vp = list_get_instance(link, viewport_t, link);
+		sysarg_t w_vp, h_vp;
+		surface_get_resolution(vp->surface, &w_vp, &h_vp);
+		rectangle_union(
+		    x_res, y_res, w_res, h_res,
+		    vp->pos.x, vp->pos.y, w_vp, h_vp,
+		    &x_res, &y_res, &w_res, &h_res);
+	}
+
+	viewport_bound_rect.x = x_res;
+	viewport_bound_rect.y = y_res;
+	viewport_bound_rect.w = w_res;
+	viewport_bound_rect.h = h_res;
+
+	fibril_mutex_unlock(&viewport_list_mtx);
+
+	fibril_mutex_lock(&pointer_list_mtx);
+
+	list_foreach(pointer_list, link) {
+		pointer_t *ptr = list_get_instance(link, pointer_t, link);
+		ptr->pos.x = ptr->pos.x > viewport_bound_rect.x ? ptr->pos.x : viewport_bound_rect.x;
+		ptr->pos.y = ptr->pos.y > viewport_bound_rect.y ? ptr->pos.y : viewport_bound_rect.y;
+		ptr->pos.x = ptr->pos.x < viewport_bound_rect.x + viewport_bound_rect.w ?
+		    ptr->pos.x : viewport_bound_rect.x + viewport_bound_rect.w;
+		ptr->pos.y = ptr->pos.y < viewport_bound_rect.y + viewport_bound_rect.h ?
+		    ptr->pos.y : viewport_bound_rect.y + viewport_bound_rect.h;
+	}
+
+	fibril_mutex_unlock(&pointer_list_mtx);
+}
+
 static void comp_damage(sysarg_t x_dmg_glob, sysarg_t y_dmg_glob,
     sysarg_t w_dmg_glob, sysarg_t h_dmg_glob)
@@ -695,4 +752,15 @@
 	}
 
+	loc_service_unregister(win->in_dsid);
+	loc_service_unregister(win->out_dsid);
+
+	/* In case the client was killed, input fibril of the window might be
+	 * still blocked on the condition within comp_window_get_event. */
+	window_event_t *event_dummy = (window_event_t *) malloc(sizeof(window_event_t));
+	if (event_dummy) {
+		link_initialize(&event_dummy->link);
+		prodcons_produce(&win->queue, &event_dummy->link);
+	}
+
 	/* Calculate damage. */
 	sysarg_t x = 0;
@@ -706,12 +774,4 @@
 	}
 
-	/* Release window resources. */
-	loc_service_unregister(win->in_dsid);
-	loc_service_unregister(win->out_dsid);
-	while (!list_empty(&win->queue.list)) {
-		list_remove(list_first(&win->queue.list));
-	}
-	window_destroy(win);
-
 	comp_damage(x, y, width, height);
 
@@ -813,4 +873,5 @@
 
 	if (win) {
+		atomic_inc(&win->ref_cnt);
 		async_answer_0(iid, EOK);
 	} else {
@@ -825,5 +886,7 @@
 
 			if (!IPC_GET_IMETHOD(call)) {
-				async_answer_0(callid, EINVAL);
+				async_answer_0(callid, EOK);
+				atomic_dec(&win->ref_cnt);
+				window_destroy(win);
 				return;
 			}
@@ -842,5 +905,7 @@
 
 			if (!IPC_GET_IMETHOD(call)) {
-				async_answer_0(callid, EINVAL);
+				comp_window_close(win, callid, &call);
+				atomic_dec(&win->ref_cnt);
+				window_destroy(win);
 				return;
 			}
@@ -857,5 +922,7 @@
 				break;
 			case WINDOW_CLOSE:
-				comp_window_close(win, callid, &call);
+				/* Postpone the closing until the phone is hung up to cover
+				 * the case when the client is killed abruptly. */
+				async_answer_0(callid, EOK);
 				break;
 			case WINDOW_CLOSE_REQUEST:
@@ -911,4 +978,5 @@
 	async_answer_0(iid, EOK);
 
+	comp_restrict_pointers();
 	comp_damage(0, 0, UINT32_MAX, UINT32_MAX);
 }
@@ -956,4 +1024,7 @@
 		fibril_mutex_unlock(&viewport_list_mtx);
 		async_answer_0(iid, EOK);
+
+		comp_restrict_pointers();
+		comp_damage(0, 0, UINT32_MAX, UINT32_MAX);
 	}
 }
@@ -1391,4 +1462,16 @@
 	surface_get_resolution(pointer->cursor.states[pointer->state], 
 	     &cursor_width, &cursor_height);
+	if (pointer->pos.x + dx < viewport_bound_rect.x) {
+		dx = -1 * (pointer->pos.x - viewport_bound_rect.x);
+	}
+	if (pointer->pos.y + dy < viewport_bound_rect.y) {
+		dy = -1 * (pointer->pos.y - viewport_bound_rect.y);
+	}
+	if (pointer->pos.x + dx > viewport_bound_rect.x + viewport_bound_rect.w) {
+		dx = (viewport_bound_rect.x + viewport_bound_rect.w - pointer->pos.x);
+	}
+	if (pointer->pos.y + dy > viewport_bound_rect.y + viewport_bound_rect.h) {
+		dy = (viewport_bound_rect.y + viewport_bound_rect.h - pointer->pos.y);
+	}
 	pointer->pos.x += dx;
 	pointer->pos.y += dy;
@@ -1910,4 +1993,5 @@
 			fibril_mutex_unlock(&viewport_list_mtx);
 
+			comp_restrict_pointers();
 			comp_damage(x, y, width, height);
 		} else {
@@ -1962,9 +2046,5 @@
 		}
 		list_prepend(&blue_win->link, &window_list);
-
-		window_t *helenos_win = window_create(0, 0);
-		helenos_win->surface = decode_tga((void *) helenos_tga, helenos_tga_size, 0);
-		list_prepend(&helenos_win->link, &window_list);
-
+		
 		window_t *nameic_win = window_create(0, 0);
 		nameic_win->surface = decode_tga((void *) nameic_tga, nameic_tga_size, 0);
@@ -2126,5 +2206,6 @@
 		return -1;
 	}
-	
+
+	comp_restrict_pointers();
 	comp_damage(0, 0, UINT32_MAX, UINT32_MAX);
 	
Index: uspace/srv/hid/console/console.c
===================================================================
--- uspace/srv/hid/console/console.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/srv/hid/console/console.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -129,5 +129,5 @@
 static void cons_set_rgb_color(con_srv_t *, pixel_t, pixel_t);
 static void cons_set_cursor_visibility(con_srv_t *, bool);
-static int cons_get_event(con_srv_t *, kbd_event_t *);
+static int cons_get_event(con_srv_t *, cons_event_t *);
 
 static con_ops_t con_ops = {
@@ -490,5 +490,5 @@
 }
 
-static int cons_get_event(con_srv_t *srv, kbd_event_t *event)
+static int cons_get_event(con_srv_t *srv, cons_event_t *event)
 {
 	console_t *cons = srv_to_console(srv);
@@ -496,5 +496,6 @@
 	kbd_event_t *kevent = list_get_instance(link, kbd_event_t, link);
 	
-	*event = *kevent;
+	event->type = CEV_KEY;
+	event->ev.key = *kevent;
 	free(kevent);
 	return EOK;
Index: uspace/srv/hid/remcons/remcons.c
===================================================================
--- uspace/srv/hid/remcons/remcons.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/srv/hid/remcons/remcons.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -80,5 +80,5 @@
 static int remcons_get_size(con_srv_t *, sysarg_t *, sysarg_t *);
 static int remcons_get_color_cap(con_srv_t *, console_caps_t *);
-static int remcons_get_event(con_srv_t *, kbd_event_t *);
+static int remcons_get_event(con_srv_t *, cons_event_t *);
 
 static con_ops_t con_ops = {
@@ -185,10 +185,11 @@
 }
 
-static int remcons_get_event(con_srv_t *srv, kbd_event_t *event)
-{
-	telnet_user_t *user = srv_to_user(srv);
+static int remcons_get_event(con_srv_t *srv, cons_event_t *event)
+{
+	telnet_user_t *user = srv_to_user(srv);
+	kbd_event_t kevent;
 	int rc;
 
-	rc = telnet_user_get_next_keyboard_event(user, event);
+	rc = telnet_user_get_next_keyboard_event(user, &kevent);
 	if (rc != EOK) {
 		/* XXX What? */
@@ -196,4 +197,7 @@
 		return EOK;
 	}
+
+	event->type = CEV_KEY;
+	event->ev.key = kevent;
 
 	return EOK;
Index: uspace/srv/net/ethip/ethip.c
===================================================================
--- uspace/srv/net/ethip/ethip.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/srv/net/ethip/ethip.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -221,6 +221,6 @@
 	case ETYPE_IP:
 		log_msg(LOG_DEFAULT, LVL_DEBUG, " - construct SDU");
-		sdu.lsrc.ipv4 = (192 << 24) | (168 << 16) | (0 << 8) | 1;
-		sdu.ldest.ipv4 = (192 << 24) | (168 << 16) | (0 << 8) | 4;
+		sdu.lsrc.ipv4 = 0;
+		sdu.ldest.ipv4 = 0;
 		sdu.data = frame.data;
 		sdu.size = frame.size;
Index: uspace/srv/ns/task.c
===================================================================
--- uspace/srv/ns/task.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/srv/ns/task.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -208,4 +208,5 @@
 	sysarg_t retval;
 	task_exit_t texit;
+	bool remove = false;
 	
 	ht_link_t *link = hash_table_find(&task_hash_table, &id);
@@ -235,5 +236,5 @@
 	}
 	
-	hash_table_remove_item(&task_hash_table, link);
+	remove = true;
 	retval = EOK;
 	
@@ -243,4 +244,6 @@
 		ipc_answer_2(callid, retval, texit, ht->retval);
 	}
+	if (remove)
+		hash_table_remove_item(&task_hash_table, link);
 }
 
